<template>
    <div id="carouselExample" class="carousel slide" data-bs-ride="carousel">
        <div class="carousel-indicators">
            <button type="button" data-bs-target="#carouselExample" data-bs-slide-to="0" class="active" aria-current="true" aria-label="Slide 1"></button>
            <button type="button" data-bs-target="#carouselExample" data-bs-slide-to="1" aria-label="Slide 2"></button>
            <button type="button" data-bs-target="#carouselExample" data-bs-slide-to="2" aria-label="Slide 3"></button>
        </div>
        <div class="carousel-inner">
            <div class="carousel-item active">
                <img class="d-block w-100" src="/assets/img/product/slide-1.jpg" alt="First slide" />
            </div>
            <div class="carousel-item">
                <img class="d-block w-100" src="/assets/img/product/slide-2.jpg" alt="Second slide" />
            </div>
            <div class="carousel-item">
                <img class="d-block w-100" src="/assets/img/product/slide-3.jpg" alt="Third slide" />
            </div>
        </div>
        <a class="carousel-control-prev" href="#carouselExample" role="button" data-bs-slide="prev">
            <span class="carousel-control-prev-icon" aria-hidden="true"></span>
            <span class="visually-hidden">Previous</span>
        </a>
        <a class="carousel-control-next" href="#carouselExample" role="button" data-bs-slide="next">
            <span class="carousel-control-next-icon" aria-hidden="true"></span>
            <span class="visually-hidden">Next</span>
        </a>
    </div>
    <div class="container product-list-category">
        <div class="row">
            <div class="col-md-3">
                <div class="card p-1">
                    <h4 class="p-2 text-center">Danh mục sản phẩm</h4>
                    <div id="my-list">
                        <ul class="list-group">
                            <template v-for="(item, index) in category" :key="index">
                                <li v-on:click="listProduct(item.id)" v-if="item.child.length == 0" class="border-radius category-level1 list-group-item d-flex justify-content-between align-items-center">
                                    <img :src="item.thumbnail" :alt="item.name" height="50" width="50">
                                    <a href="javascript:void(0)" v-on:click="listProduct(item.id)" >{{ item.name }}</a>
                                    <span class="badge bg-primary rounded-pill">{{ item.get_products_count }}</span>
                                </li>
                                <template v-else>
                                    <li v-if="item.child.length > 0" class="border-radius category-level1 list-group-item d-flex justify-content-between align-items-center" 
                                        data-toggle="collapse" data-target="#set01" data-parent="#my-list">
                                        <img :src="item.thumbnail" :alt="item.name" height="50" width="50">
                                        <a href="javascript:void(0)" v-on:click="listProduct(item.id)" >{{ item.name }}</a>
                                        <span>
                                            <span class="badge bg-primary rounded-pill">{{ item.get_products_count }}</span>
                                            <i class="fa-solid fa-chevron-down"></i>
                                        </span>
                                    </li>
                                    <span class="glyphicon glyphicon-menu-down text-color-red pull-right"></span>
                                    <ul class="sublinks collapse" id="set01">
                                        <template v-for="(child,i) in item.child" :key="i">
                                            <li v-on:click="listProduct(child.id)" class="border-radius list-group-item d-flex justify-content-between align-items-center">
                                                <i class="fa-solid fa-circle"></i>
                                                <a href="javascript:void(0)">{{ child.name }}</a>
                                                <span class="badge bg-primary rounded-pill">{{ child.get_products_count }}</span>
                                            </li>
                                        </template>
                                    </ul>
                                </template>
                            </template>
                        </ul>
                    </div>
                </div>
                <div class="card p-1 mt-2">
                    <h4 class="p-2 text-center">Mức giá</h4>
                    <div class="p-2">
                        <div class="form-check m-2">
                            <input v-on:click="listProductByPrice(0)" v-model="search.price" :value="0" class="form-check-input" type="radio" name="price" id="all">
                            <label class="form-check-label" for="all">
                                Tất cả
                            </label>
                        </div>
                        <div class="form-check m-2">
                            <input v-on:click="listProductByPrice(1)" v-model="search.price" :value="1" class="form-check-input" type="radio" name="price" id="min1">
                            <label class="form-check-label" for="min1">
                               Dưới 2 triệu
                            </label>
                        </div>
                        <div class="form-check m-2">
                            <input v-on:click="listProductByPrice(2)" v-model="search.price" :value="2" class="form-check-input" type="radio" name="price" id="min2">
                            <label class="form-check-label" for="min2">
                               Từ 2 - 4 triệu
                            </label>
                        </div>
                        <div class="form-check m-2">
                            <input v-on:click="listProductByPrice(3)" v-model="search.price" :value="3" class="form-check-input" type="radio" name="price" id="min3">
                            <label class="form-check-label" for="min3">
                                Từ 4 - 7 triệu
                            </label>
                        </div>
                        <div class="form-check m-2">
                            <input v-on:click="listProductByPrice(4)" v-model="search.price" :value="4" class="form-check-input" type="radio" name="price" id="min4">
                            <label class="form-check-label" for="min4">
                                Từ 7 - 13 triệu
                            </label>
                        </div>
                        <div class="form-check m-2">
                            <input v-on:click="listProductByPrice(5)" v-model="search.price" :value="5" class="form-check-input" type="radio" name="price" id="min5">
                            <label class="form-check-label" for="min5">
                                Trên 13 triệu
                            </label>
                        </div>
                    </div>
                </div>
                
            </div>
            <div class="col-md-9">
                <div class="row row-cols-3">
                    <template v-for="(product, index) in products" :key="index">
                        <div class="col item mt-2">
                            <a :href="'san-pham/' + product.slug">
                                <div class="card h-100">
                                    <div class="sale p-1">
                                        <span class="price-sale">Giảm {{ new Intl.NumberFormat().format(product.price * (product.sale/100)) }} </span>
                                        <img v-bind:style="{ backgroundImage: 'url(' + product.thumbnail + ')' }" class="card-img-top" src="assets/img/user/sale.png" :alt="product.name" />
                                    </div>
                                    <div class="card-body pt-1">
                                        <a href="#">
                                            <span class="card-title fs-16 fw-500">{{ product.name }}</span>
                                        </a>
                                        <div class="price d-flex justify-content-between pt-1 align-items-center">
                                            <span class="price-new fs-14">{{ new Intl.NumberFormat().format(product.price * ((100 -product.sale)/100)) }}</span>
                                            <span class="price-old fs-14">{{ new Intl.NumberFormat().format(product.price) }}</span>
                                        </div>
                                        <div class="pt-1">
                                            <div class="star">
                                                <span v-for="(star, index) in roundedNum(product.point)" :key="index" class="fa-stack m-1" style="width:1em;">
                                                    <i v-if="star > product.point" class="fas fa-star-half fa-stack-1x"></i>
                                                    <i v-else class="fas fa-star fa-stack-1x"></i>
                                                </span>
                                            </div>
                                        </div>
                                        <span class="fs-14 pt-2 d-flex">Giảm thêm 5% khi thanh toán online</span>
                                    </div>
                                </div>
                            </a>
                        </div>
                    </template>
                </div>
                <template v-if="products.length == 0">
                    <div class="order d-flex align-items-center justify-content-center" style="height: 500px;">
                        <div>
                            <img src="/assets/img/order.png" alt width="200" height="200">
                            <p class="text-center">Không có sản phẩm nào</p>
                        </div>
                    </div>
                </template>
            </div>
        </div>
    </div>
</template>

<script>
const { Toast } = bootstrap
    export default {
        name: 'product-list',
        data(){
            return {
               products: [],
               category: [],
               search: {
                category: 0,
                price: 0,
                keyword: ''
               }
            }
        },
        props:{
            
        },
        methods:{
            listProduct(category_id, key = ''){
                this.products = [];
                this.search.category = category_id;
                this.search.keyword = key;
                console.log(this.search);
                this.$store.dispatch('listProduct', this.search).then(res => {
                    this.products = res.data.data;
                });
            },
            listProductByPrice(price){
                this.products = [];
                this.search.price = price;
                this.$store.dispatch('listProduct', this.search).then(res => {
                    this.products = res.data.data;
                });
            },
            listCategory(){
                this.$store.dispatch('listCategory').then(res => {
                    this.category = res.data;
                    this.category.map((item) => {
                        item.child.map((child) => {
                            item.get_products_count += child.get_products_count
                        })
                    })
                });
            },
            roundedNum(num) {
                return Math.round(num);
            },
        },
        mounted() {
            let url = new URL(window.location.href);
            let param = url.searchParams.get("cat");
            let key = url.searchParams.get("keyword");
            this.listProduct(param ?? 0, key ?? '');
            this.listCategory();
        }
    }
</script>
<style lang="scss">
.product-list-category {
    padding-top: 10px;
    .card-img-top {
        width: 100%;
        height: 240px;
        transition: transform 1s;
        border-radius: 5%;
        background-repeat: no-repeat;
        background-position: center center;
        background-size: cover;
    }
    .border-radius {
        img {
            border-radius: 5px;
        }
        i{
            font-size: 10px;
        }
        border: none;
        cursor: pointer;
        border-radius: 0px;
        border-top: 1px solid #d9dee3;
        .badge {
            margin: 10px;
        }
    }
    .category-level1 {
        background-color: rgba(67, 89, 113, 0.04);
    }
    .list-group-item-linkable:hover {
    color: #555;
    text-decoration: none;
    background-color: #f5f5f5;
    cursor: pointer;
}
}
</style>